unit mp3x;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, AppEvnts, Gauges, StdCtrls, Mask, DBCtrls, Db, ADODB,
  ExtCtrls, Grids, DBGrids, Menus, MPlayer, FileCtrl, Buttons, mmsystem,
  OleCtrls, Chartfx3, VCFI, TeeProcs, TeEngine, Chart, Series, TeeFunci;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    maplayer: TMediaPlayer;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    ProgressBar1: TProgressBar;
    MainMenu1: TMainMenu;
    Datoteka1: TMenuItem;
    Zapri1: TMenuItem;
    PomoPodatki1: TMenuItem;
    Avtor1: TMenuItem;
    N1: TMenuItem;
    Razliica1: TMenuItem;
    Tevae1: TMenuItem;
    Timer1: TTimer;
    FilterComboBox1: TFilterComboBox;
    Bevel1: TBevel;
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    lblMP3: TLabel;
    N2: TMenuItem;
    RadioButton1: TRadioButton;   //Continuous play mode
    RadioButton2: TRadioButton;   //Repeat play mode
    RadioButton3: TRadioButton;   //Shuffle play mode
    RadioButton4: TRadioButton;   //Normal play mode
    StaticText1: TStaticText;
    MP3BAZA1: TMenuItem;
    Odpribazo1: TMenuItem;
    TrackBar1: TTrackBar;  //handles the VOLUME
    TrackBar2: TTrackBar;  //handles the BALANCE
    lblProcenti: TLabel;
    Label2: TLabel;
    procedure FormResize(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure ProgressBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure maplayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure Zapri1Click(Sender: TObject);
    procedure Avtor1Click(Sender: TObject);
    procedure Razliica1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Odpribazo1Click(Sender: TObject);
    procedure Tevae1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure lblProcentiDblClick(Sender: TObject);
    procedure StaticText1DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

 private
    { Private declarations }
    index_komada: integer;
    times: string;   //needed to alter the PLAY TIME style
    procedure playmp3(playme: boolean);
    
  public
   test: string;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;


{$R *.DFM}

procedure SetWavVolume(Lewy,Prawy:Byte);        //our own procedure for setting the output volume
begin
  waveOutSetVolume(WAVE_MAPPER, Integer((Lewy shl 24) or (Prawy shl 8)));
end; 

procedure tform1.playmp3(playme: boolean);      //our own procedure for the player to open & play
begin

if playme then
begin
   StatusBar1.Panels[0].text:=filelistbox1.FileName;    //in panel 0 shows the file name
   RadioButton1.Enabled:=true;                          //enables continuous
   RadioButton2.Enabled:=true;                          //enables repeat
   RadioButton3.Enabled:=True;                          //enables shuffle
   maplayer.Filename := FileListBox1.FileName;          //sets the song into the mediaplayer
   maplayer.Open;
   maplayer.Play;
   ProgressBar1.Max := maplayer.Length;                 //initializes the length of progress bar
   Timer1.Enabled := true;
end;

end;

procedure TForm1.FormResize(Sender: TObject);         //what happens with other objects on resize
begin
   progressbar1.Top :=  FileListBox1.Height + 83;
   maplayer.top :=  FileListBox1.Height + 102;
end;

procedure TForm1.DriveComboBox1Change(Sender: TObject);   //enables explorer style
begin

   DriveComboBox1.DirList := DirectoryListBox1;
   DirectoryListBox1.FileList := FileListBox1;

end;

procedure TForm1.FileListBox1Change(Sender: TObject);   //affects the media player's buttons through verifying the progressbar position
begin
    if FileListBox1.FileName <> '' then
      begin
         if ProgressBar1.Position > 0 then begin
            maplayer.EnabledButtons := [btplay,btnext,btprev,btstop];
         end
         else
            maplayer.EnabledButtons := [btPlay,btnext,btprev];
      end;

    if (FileListBox1.FileName = maplayer.FileName) and (maplayer.FileName <> '') then
      begin
         maplayer.EnabledButtons := [btpause,btstop,btnext,btprev];
      end;
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
try
   maplayer.EnabledButtons := [btPrev,btNext,btStop,btPause];   //those buttons become enabled
   playmp3(true);    // our prodeure for playing enables
   index_komada := FileListBox1.ItemIndex;    //the file gets indexed (needed later on)
except
   ShowMessage('The mp3 cannot be played!');
end;
end;

procedure TForm1.ProgressBar1MouseDown(Sender: TObject;   //what happens as we click on the progressbar
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
f : string;
begin
try
   if Button = mbLeft then       //the left mouse button
   f := floattostr(((maplayer.length div (Form1.Width - 8)) * x));  //calculates the new position of...
   ProgressBar1.Position := strtoint(f);          //...mediaplayer on the basis of progressbar position
   maplayer.Position := strtoint(f);
   maplayer.Play;
   Timer1.Enabled := true;
   maplayer.EnabledButtons := [btpause,btNext,btPrev,btstop];
except
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var x, t : integer;   //t=mediaplayer's position; x=the random number for "shuffle"
    min, sec : integer;   //minutes, seconds  in calculations!!
    s1, s2, result : string; // minutes(s1), seconds(s2) when displayed as result
begin

if (times = 'counting') or (times= '') then  //shows the play time of the song (counting)
 begin
   t:=maplayer.Position;
   sec := t div 1000;
   min := sec div 60;
   sec := (sec - min * 60);
   if min >9 then s1 := intToStr(min)
   else s1 := '0' + intToStr(min);
   if sec >9 then s2 := intToStr(sec)
   else s2 := '0' + intToStr(sec);
   result := S1 + ':' + S2;
   StaticText1.Caption:=' Time: '+result+' ';
 end
else        //shows the play time of the song (counting out)
 begin
   try
   t:= maplayer.Length - maplayer.Position;
   sec := t div 1000;
   min := sec div 60;
   sec := (sec - min * 60);
   if min >9 then s1 := intToStr(min)
   else s1 := '0' + intToStr(min);
   if sec >9 then s2 := intToStr(sec)
   else s2 := '0' + intToStr(sec);
   result := S1 + ':' + S2;
   StaticText1.Caption:=' Time: '+result+' ';
   except
   end
 end;

   // Displays the position of the song in progress bar
   ProgressBar1.Position := maplayer.Position;

   ///////// "N" handles the Normal play mode /////////////
   if RadioButton4.Checked=true then
   begin
      RadioButton2.checked:=false;
      RadioButton2.checked:=false;
      RadioButton3.checked:=false;
   end;
   ///////// Handles the CONTINUOUS PLAY mode /////////////
   if RadioButton1.Checked=true then
   begin
      RadioButton2.checked:=false;
      RadioButton3.checked:=false;
      if maplayer.Position=ProgressBar1.Max then
      begin
         Timer1.Enabled := false;
         ProgressBar1.Position := 0;
         FileListBox1.ItemIndex :=  fileListBox1.ItemIndex + 1;
         maplayer.EnabledButtons := [btpause,btstop,btPrev,btNext];
         try
            playmp3(true);
         except;
         end;
      end;
      if FileListBox1.Count = 0 then
       begin
          maplayer.EnabledButtons:=[];
       end;
   end;
   /////////// Handles the REPEAT mode /////////
   if RadioButton2.Checked=true then
   begin
      RadioButton1.checked:=false;
      RadioButton3.checked:=false;
      if maplayer.Position=ProgressBar1.Max then
         begin
            Timer1.Enabled := false;
            ProgressBar1.Position := 0;
            maplayer.EnabledButtons := [btpause,btstop,btPrev,btNext];
            try
               playmp3(true);
            except;
         end;
      if FileListBox1.Count = 0 then
       begin
          maplayer.EnabledButtons:=[];
       end;
      end;
   end;
   /////////// Handles the SHUFFLE mode /////////
   if RadioButton3.Checked=true then
   begin
      Timer1.Enabled := true;
      RadioButton1.checked:=false;
      RadioButton2.checked:=false;
      if maplayer.Position=ProgressBar1.Max then
         begin
            ProgressBar1.Position := 0;
            x:=random(FileListBox1.Count);
            FileListBox1.ItemIndex:=random(FileListBox1.ItemIndex+x);
            maplayer.EnabledButtons := [btpause,btstop,btPrev,btNext];
            try
               playmp3(true);
            except;
         end;
       if FileListBox1.Count = 0 then
         begin
           Timer1.Enabled:=False;
           ProgressBar1.Position:=0;
           maplayer.EnabledButtons:=[];
         end;
      end;
   end;
end;

////////

procedure TForm1.maplayerClick(Sender: TObject; Button: TMPBtnType; //all what happens while clicking different mediaplayer buttons
  var DoDefault: Boolean);
begin
dodefault := false;
case button of         // when you click .......

btnext:     // .. "NEXT" button
   begin
         Timer1.Enabled := false;
         ProgressBar1.Position := 0;
         FileListBox1.ItemIndex :=  fileListBox1.ItemIndex + 1;
         maplayer.EnabledButtons := [btpause,btstop,btPrev,btNext];
         try
            playmp3(true);
         except;
         end;
   end;

btprev:    // .. "PREVIOUS" button
   begin
      Timer1.Enabled := false;
      ProgressBar1.Position := 0;
      FileListBox1.ItemIndex :=  fileListBox1.ItemIndex - 1;
      maplayer.EnabledButtons := [btpause,btstop,btPrev,btNext];
         try
            playmp3(true);
         except
         end;
   end;

btstop:    // .. "STOP" button
   begin
   Timer1.Enabled := false;
   ProgressBar1.Position := 0;
      try
         maplayer.Stop;
         maplayer.EnabledButtons := [btPlay,btPrev,btNext];
      except
      end;
   end;

btpause:    // .. "PAUSE" button
   begin
      try
         maplayer.EnabledButtons := [btPlay,btstop,btPrev,btNext];
         maplayer.Pause;
         Timer1.Enabled := false;
      except
      end;
   end;

btplay:      // .. "PLAY" button
   begin
    maplayer.EnabledButtons := [btpause,btstop,btPrev,btNext];
    if index_komada = FileListBox1.ItemIndex then
      begin
      if ProgressBar1.Position = 0 then
         begin
            try
               playmp3(true);
               index_komada := FileListBox1.ItemIndex;
            except
            end;
         end
      else
      begin
         try
            maplayer.Play;
            Timer1.Enabled := true;
         except;
         end;
      end;
      end
    else
      try
         playmp3(true);
         index_komada := FileListBox1.ItemIndex;
       except
       end;
    end;
   end;

end;

/////////

procedure TForm1.DirectoryListBox1Change(Sender: TObject);  //the event of changing the directory
begin
   if FileListBox1.Count > 0 then
      maplayer.EnabledButtons := [btNext,btprev]
end;
/////////

procedure TForm1.Zapri1Click(Sender: TObject); // while you want to terminate the program
begin
   if MessageDlg('Are you sure you want to leave the program?',mtWarning,[mbYes,mbNo],0)=mrYes then form1.Close;
end;
/////
procedure TForm1.Avtor1Click(Sender: TObject);
begin
  Application.MessageBox('Authors: A.K. & E.Z. , Slovenia.','Authorship',0);
end;
//////
procedure TForm1.Razliica1Click(Sender: TObject);
begin
  Application.MessageBox('The program version is 1.6.7.','Version',0);
end;
//////
procedure TForm1.FormCreate(Sender: TObject);
var a:double;    //double is a kind of extended variable
begin
  RadioButton4.Checked:=true;
  FilterComboBox1.FileList:=FileListBox1;  //filters what files will be shown in filelistbox
  TrackBar2.Max := TrackBar1.Position;   //balance max=volume position
  TrackBar2.Min := - TrackBar2.Max;      //balance min= - balance max
  TrackBar2.Max := TrackBar1.Position;
  TrackBar2.Min := - TrackBar2.Max;

  a := ((TrackBar2.Position / TrackBar2.Max) * 100); // --->  handles the compatibility of volume and balance
  lblProcenti.Caption := formatfloat('0',(a)) + '%';
  if TrackBar2.Position < 0 then
     SetWavVolume(TrackBar1.Position, TrackBar2.Max + (TrackBar2.Position))
  else
     SetWavVolume(TrackBar2.Max - TrackBar2.Position , TrackBar1.Position);
     lblProcenti.Caption:='Balance: 0%';  //the default set
  end;   // <---

///////

procedure TForm1.Odpribazo1Click(Sender: TObject);  //opens the DATABASE form
begin
        try
        maplayer.stop;
        except
        end;
        baza.showmodal;  //shows the "baza" form
end;
/////
procedure TForm1.Tevae1Click(Sender: TObject);   //Problems messagebox
begin
        MessageDlg('In case of having problems try installing MS MediaPlayer 7.',mtInformation,[mbOk],0);
end;

/////
procedure TForm1.TrackBar1Change(Sender: TObject);   //volume changing
begin
    SetWavVolume(TrackBar1.Position ,TrackBar1.Position);  // sets both channels at once
end;

/////
procedure TForm1.TrackBar2Change(Sender: TObject);   //balance changing
var a: double;
begin
    TrackBar2.Max := TrackBar1.Position;
    TrackBar2.Min := - TrackBar2.Max;

a := ((TrackBar2.Position / TrackBar2.Max) * 100);    //calculates the percentage
lblProcenti.Caption := 'Balance: '+formatfloat('0',(a)) + '%'; //special procedure to cut the decimals of the extended number

if TrackBar2.Position < 0 then  // if set lower than half then silences the left channel
SetWavVolume(TrackBar1.Position, TrackBar2.Max + (TrackBar2.Position))
else      // if set higher than half then silences right channel
SetWavVolume(TrackBar2.Max - TrackBar2.Position , TrackBar1.Position);

end;


procedure TForm1.lblProcentiDblClick(Sender: TObject);
begin
     TrackBar2.Position := 0;  // on double click sets the balance position to default 0
end;


procedure TForm1.StaticText1DblClick(Sender: TObject); // displays counting or counting out
begin       // this refers to the very first code in Timer1 procedure!
if (times = '') or (times = 'counting') then
   times:= 'counting_out'
else
   times:= 'counting'
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
timer1.Destroy;
end;

end.
